#include "zcommon.acs"
#include "ELO.acs"

#Define PLAYERMAX 64

int fragcount[2];
int deathcount[2];
int duelplayer[64];
int duelplayernum[2];
int active_players;
int roundinprogress;
int roundover;
int whimp;
int joined[PLAYERMAX];

function int max (int a, int b)
{
	if (a > b)
		return a;

	return b;
}

script 350 ENTER
{
	joined[playernumber()] = 1;
	int secs = 0;
	while(PlayerIsLoggedIn(playernumber()) == 0)
    {
        SetFont("smallfont");
		print(s:"You have 5 seconds to login or you will be kicked");
        delay(35);
		if (secs == 5)
		{
			kickfromgame(playernumber(), "Failed to login");
			terminate;
		}
		else
			secs++;
    }
	str yourname = GetPlayerAccountName(playernumber()); //initialize player's account
    if (GetDBEntry("PlayerElosProv", yourname ) == 0)
	{
		SetDBEntry("PlayerElosProv", yourname, 1200);
		SetDBEntry("GamesPlayed", yourname, 0);
	}
	if (GetDBEntry("Rankable", yourname ) == 1) //show your Elo (provisional or ranked) and update at round end
	{
		hudmessage(s:"Your ELO:\n",i:GetDBEntry("PlayerElos", yourname),s:"\nRank: ",i:GetDBEntryRank("PlayerElos", yourname, TRUE);
                HUDMSG_PLAIN, 304, CR_WHITE, 0.05, 0.8, 0);
		while (roundover == 0)
		{
			delay(35);
		}
		delay(1);
		str yourname = GetPlayerAccountName(playernumber()); 
		setfont("smallfont");
		hudmessage(s:"Your ELO:\n",i:GetDBEntry("PlayerElos", yourname),s:"\nRank: ",i:GetDBEntryRank("PlayerElos", yourname, TRUE);
                HUDMSG_PLAIN, 304, CR_WHITE, 0.05, 0.8, 0);
	}
	else
	{
		hudmessage(s:"Your ELO:\n",i:GetDBEntry("PlayerElosProv", yourname),s:"\nComplete 10 matches\nto be ranked.";
            HUDMSG_PLAIN, 304, CR_WHITE, 0.05, 0.8, 0);
		while (roundover == 0)
		{
			delay(35);
		}
		delay(1);
		str yourname = GetPlayerAccountName(playernumber()); 
		if (GetDBEntry("Rankable", yourname ) == 1)
		{
			setfont("smallfont");
			hudmessage(s:"Your ELO:\n",i:GetDBEntry("PlayerElos", yourname),s:"\nRank: ",i:GetDBEntryRank("PlayerElos", yourname, TRUE);
                HUDMSG_PLAIN, 304, CR_WHITE, 0.05, 0.8, 0);
		}
		else
		{
			setfont("smallfont");
			hudmessage(s:"Your ELO:\n",i:GetDBEntry("PlayerElosProv", yourname),s:"\nComplete 10 matches\nto be ranked.";
				HUDMSG_PLAIN, 304, CR_WHITE, 0.05, 0.8, 0);
		}
	}
}

Script 353 (int type, int arg1, int arg2 ) EVENT
{
    switch (Type) {
    case GAMEEVENT_ROUND_ENDS:
        if (roundinprogress == 0) 
			terminate; //don't do anything if the game didn't properly start
		if (GetLevelInfo(LEVELINFO_LEVELNUM) == 33)
		{
			print(s:"Note: Shoot is not ranked");
			terminate;
		}
		delay(1);
		roundover = 1;
		str name0 = GetPlayerAccountName(duelplayernum[0]);
		str name1 = GetPlayerAccountName(duelplayernum[1]);
		int name0R = GetDBEntry("Rankable", name0);
		int name1R = GetDBEntry("Rankable", name1);
		int oldelo0, oldelo1;
		if (name0R == 1) //get either ranked or non ranked Elo
			oldelo0 = GetDBEntry("PlayerElos", name0 );
		else
			oldelo0 = GetDBEntry("PlayerElosProv", name0 );
		if (name1R == 1)
			oldelo1 = GetDBEntry("PlayerElos", name1 );
		else
			oldelo1 = GetDBEntry("PlayerElosProv", name1 );
		BeginDBTransaction();
		IncrementDBEntry("GamesPlayed", name0, 1); //increase number of games played
		IncrementDBEntry("GamesPlayed", name1, 1);
		EndDBTransaction();
		int name0GP = GetDBEntry("GamesPlayed", name0);
		int name1GP = GetDBEntry("GamesPlayed", name1);
		if	(name0R == 0 && name0GP > 9) //check if more than 10 games have been played, if so allow the player to be ranked
		{
			SetDBEntry("Rankable", name0, 1);
			name0R = 1;
		}
		if	(name1R == 0 && name1GP > 9)
		{
			SetDBEntry("Rankable", name1, 1);
			name1R = 1;
		}
		BeginDBTransaction();
		IncrementDBEntry("TotalFrags", name0, fragcount[0]); //update frag/death stats
		IncrementDBEntry("TotalFrags", name1, fragcount[1]);
		IncrementDBEntry("TotalDeaths", name0, deathcount[0]);
		IncrementDBEntry("TotalDeaths", name1, deathcount[1]);
		EndDBTransaction();
		int newelo0, newelo1;
		if (fragcount[0] > fragcount[1]) 
		{
			newelo0 = elo(oldelo0, oldelo1, 16, 1); //calculate new Elo scores
			newelo1 = oldelo1 - (newelo0 - oldelo0);
			setfont("Bigfont");
			hudmessage(n:duelplayernum[0] + 1,s:" \ccawarded \cf",i:newelo0 - oldelo0,s:"\cc elo points!\n\n",n:duelplayernum[1] + 1,s:" \ccawarded \cg",i:newelo1 - oldelo1,s:"\cc elo points!\n\n";
				HUDMSG_PLAIN | HUDMSG_LOG, 311, CR_WHITE, 0.5, 0.6, 0);
			BeginDBTransaction();
			if (name0R == 1) //store Elo scores
				SetDBEntry("PlayerElos", name0, max(newelo0,500));
			else
				SetDBEntry("PlayerElosProv", name0, max(newelo0,500));
			if (name1R == 1)
				SetDBEntry("PlayerElos", name1, max(newelo1,500));
			else
				SetDBEntry("PlayerElosProv", name1, max(newelo1,500));
			EndDBTransaction();
			if (getcvar("elo_logmatches") == 1)
			{
				IncrementDBEntry("DuelElo","GameCount",1);
				int matchid = GetDBEntry("DuelElo","GameCount");
				str matchid_result = strparam(i:matchid,s:"_result");
				str matchid_map = strparam(i:matchid,s:"_map");
				str mapname = strparam(n:PRINTNAME_LEVEL);
				str matchid_player0 = strparam(i:matchid,s:"_player0");
				str matchid_player1 = strparam(i:matchid,s:"_player1");
				str matchid_player0_Frags = strparam(i:matchid,s:"_player0_Frags");
				str matchid_player1_Frags = strparam(i:matchid,s:"_player1_Frags");
				BeginDBTransaction();
				SetDBEntry("MatchResults",matchid_result,0); //0 = player 0 wins, 1 = player 1 wins, 2 = tie, 3 = player 0 ragequit, 4 = player 1 ragequit
				SetDBEntryString("MatchResults",matchid_player0,name0);
				SetDBEntryString("MatchResults",matchid_player1,name1);
				SetDBEntryString("MatchResults",matchid_map,mapname);
				SetDBEntry("MatchResults",matchid_player0_Frags,fragcount[0]);
				SetDBEntry("MatchResults",matchid_player1_Frags,fragcount[1]);
				EndDBTransaction();
			}
		}
		else if (fragcount[1] > fragcount[0])
		{
			newelo1 = elo(oldelo1, oldelo0, 16, 1);
			newelo0 = oldelo0 - (newelo1 - oldelo1);
			setfont("Bigfont");
			hudmessage(n:duelplayernum[0] + 1,s:" \ccawarded \cg",i:newelo0 - oldelo0,s:"\cc elo points!\n\n",n:duelplayernum[1] + 1,s:" \ccawarded \cf",i:newelo1 - oldelo1,s:"\cc elo points!\n\n";
				HUDMSG_PLAIN | HUDMSG_LOG, 311, CR_WHITE, 0.5, 0.6, 0);
			BeginDBTransaction();
			if (name0R == 1)
				SetDBEntry("PlayerElos", name0, max(newelo0,500));
			else
				SetDBEntry("PlayerElosProv", name0, max(newelo0,500));
			if (name1R == 1)
				SetDBEntry("PlayerElos", name1, max(newelo1,500));
			else
				SetDBEntry("PlayerElosProv", name1, max(newelo1,500));
			EndDBTransaction();
			if (getcvar("elo_logmatches") == 1)
			{
				IncrementDBEntry("DuelElo","GameCount",1);
				int matchid = GetDBEntry("DuelElo","GameCount");
				str matchid_result = strparam(i:matchid,s:"_result");
				str matchid_player0 = strparam(i:matchid,s:"_player0");
				str matchid_player1 = strparam(i:matchid,s:"_player1");
				str matchid_player0_Frags = strparam(i:matchid,s:"_player0_Frags");
				str matchid_player1_Frags = strparam(i:matchid,s:"_player1_Frags");
				str matchid_map = strparam(i:matchid,s:"_map");
				str mapname = strparam(n:PRINTNAME_LEVEL);
				BeginDBTransaction();
				SetDBEntry("MatchResults",matchid_result,1); //0 = player 0 wins, 1 = player 1 wins, 2 = tie, 3 = player 0 ragequit, 4 = player 1 ragequit
				SetDBEntryString("MatchResults",matchid_player0,name0);
				SetDBEntryString("MatchResults",matchid_player1,name1);
				SetDBEntryString("MatchResults",matchid_map,mapname);
				SetDBEntry("MatchResults",matchid_player0_Frags,fragcount[0]);
				SetDBEntry("MatchResults",matchid_player1_Frags,fragcount[1]);
				EndDBTransaction();
			}
		}
		else
		{
			newelo0 = elo(oldelo0, oldelo1, 16, 0.5);
			newelo1 = elo(oldelo1, oldelo0, 16, 0.5);
			setfont("Bigfont");
			hudmessage(n:duelplayernum[0] + 1,s:" \ccawarded ",i:newelo0 - oldelo0,s:"\cc elo points!\n\n",n:duelplayernum[1] + 1,s:" \ccawarded ",i:newelo1 - oldelo1,s:"\cc elo points!\n\n";
				HUDMSG_PLAIN | HUDMSG_LOG, 311, CR_WHITE, 0.5, 0.6, 0);
			BeginDBTransaction();
			if (name0R == 1)
				SetDBEntry("PlayerElos", name0, max(newelo0,500));
			else
				SetDBEntry("PlayerElosProv", name0, max(newelo0,500));
			if (name1R == 1)
				SetDBEntry("PlayerElos", name1, max(newelo1,500));
			else
				SetDBEntry("PlayerElosProv", name1, max(newelo1,500));
			EndDBTransaction();
			if (getcvar("elo_logmatches") == 1)
			{
				IncrementDBEntry("DuelElo","GameCount",1);
				int matchid = GetDBEntry("DuelElo","GameCount");
				str matchid_result = strparam(i:matchid,s:"_result");
				str matchid_player0 = strparam(i:matchid,s:"_player0");
				str matchid_player1 = strparam(i:matchid,s:"_player1");
				str matchid_player0_Frags = strparam(i:matchid,s:"_player0_Frags");
				str matchid_player1_Frags = strparam(i:matchid,s:"_player1_Frags");
				str matchid_map = strparam(i:matchid,s:"_map");
				str mapname = strparam(n:PRINTNAME_LEVEL);
				BeginDBTransaction();
				SetDBEntry("MatchResults",matchid_result,2); //0 = player 0 wins, 1 = player 1 wins, 2 = tie, 3 = player 0 ragequit, 4 = player 1 ragequit
				SetDBEntryString("MatchResults",matchid_player0,name0);
				SetDBEntryString("MatchResults",matchid_player1,name1);
				SetDBEntryString("MatchResults",matchid_map,mapname);
				SetDBEntry("MatchResults",matchid_player0_Frags,fragcount[0]);
				SetDBEntry("MatchResults",matchid_player1_Frags,fragcount[1]);
				EndDBTransaction();
			}
		}
		roundinprogress = 0;
        break;
	case GAMEEVENT_PLAYERFRAGS:
		if (roundinprogress == 0)
			terminate;
		fragcount[duelplayer[playernumber()]] = playerfrags();
		break;
	case GAMEEVENT_ROUND_STARTS:
		if (getlevelinfo(LEVELINFO_CLUSTERNUM) != 99)
			roundinprogress = 1;
		break;
	case GAMEEVENT_ROUND_ABORTED: //a ragequit counts as a loss for the ragequitter
		if (roundinprogress == 1 && getlevelinfo(LEVELINFO_CLUSTERNUM) != 99)
		{
			if (GetLevelInfo(LEVELINFO_LEVELNUM) == 33)
			{
			print(s:"Note: Shoot is not ranked");
			terminate;
			}
			delay(1);
			roundover = 1;
			str TempNamespace = strparam(i:getcvar("Elo_ServerID"),s:"_TempNames");
			str name0 = GetDBEntryString (TempNamespace, "Player0");
			str name1 = GetDBEntryString (TempNamespace, "Player1");
			int name0R = GetDBEntry("Rankable", name0);
			int name1R = GetDBEntry("Rankable", name1);
			int oldelo0, oldelo1;
			if (name0R == 1)
				oldelo0 = GetDBEntry("PlayerElos", name0 );
			else
				oldelo0 = GetDBEntry("PlayerElosProv", name0 );
			if (name1R == 1)
				oldelo1 = GetDBEntry("PlayerElos", name1 );
			else
				oldelo1 = GetDBEntry("PlayerElosProv", name1 );
			int newelo0, newelo1;
			BeginDBTransaction();
			IncrementDBEntry("TotalFrags", name0, fragcount[0]);
			IncrementDBEntry("TotalFrags", name1, fragcount[1]);
			IncrementDBEntry("TotalDeaths", name0, deathcount[0]);
			IncrementDBEntry("TotalDeaths", name1, deathcount[1]);
			EndDBTransaction();
			if (duelplayer[whimp] == 1)
			{
				newelo0 = elo(oldelo0, oldelo1, 16, 1);
				newelo1 = oldelo1 - (newelo0 - oldelo0);
				setfont("Bigfont");
				hudmessage(s:name0,s:" \ccawarded \cf",i:newelo0 - oldelo0,s:"\cc elo points!\n\n",s:name1,s:" \ccawarded \cg",i:newelo1 - oldelo1,s:"\cc elo points!\n\n";
				HUDMSG_PLAIN | HUDMSG_LOG, 311, CR_WHITE, 0.5, 0.6, 0);
				BeginDBTransaction();
				if (name0R == 1)
					SetDBEntry("PlayerElos", name0, max(newelo0,500));
				else
					SetDBEntry("PlayerElosProv", name0, max(newelo0,500));
				if (name1R == 1)
					SetDBEntry("PlayerElos", name1, max(newelo1,500));
				else
					SetDBEntry("PlayerElosProv", name1, max(newelo1,500));
				EndDBTransaction();
				if (getcvar("elo_logmatches") == 1)
				{
					IncrementDBEntry("DuelElo","GameCount",1);
					int matchid = GetDBEntry("DuelElo","GameCount");
					str matchid_result = strparam(i:matchid,s:"_result");
					str matchid_player0 = strparam(i:matchid,s:"_player0");
					str matchid_player1 = strparam(i:matchid,s:"_player1");
					str matchid_player0_Frags = strparam(i:matchid,s:"_player0_Frags");
					str matchid_player1_Frags = strparam(i:matchid,s:"_player1_Frags");
					str matchid_map = strparam(i:matchid,s:"_map");
					str mapname = strparam(n:PRINTNAME_LEVEL);
					BeginDBTransaction();
					SetDBEntry("MatchResults",matchid_result,4); //0 = player 0 wins, 1 = player 1 wins, 2 = tie, 3 = player 0 ragequit, 4 = player 1 ragequit
					SetDBEntryString("MatchResults",matchid_player0,name0);
					SetDBEntryString("MatchResults",matchid_player1,name1);
					SetDBEntryString("MatchResults",matchid_map,mapname);
					SetDBEntry("MatchResults",matchid_player0_Frags,fragcount[0]);
					SetDBEntry("MatchResults",matchid_player1_Frags,fragcount[1]);
					EndDBTransaction();
				}
			}
			else if (duelplayer[whimp] == 0)
			{
				newelo1 = elo(oldelo1, oldelo0, 8, 1);
				newelo0 = oldelo0 - (newelo1 - oldelo1);
				setfont("Bigfont");
				hudmessage(s:name0,s:" \ccawarded \cg",i:newelo0 - oldelo0,s:"\cc elo points!\n\n",s:name1,s:" \ccawarded \cf",i:newelo1 - oldelo1,s:"\cc elo points!\n\n";
				HUDMSG_PLAIN | HUDMSG_LOG, 311, CR_WHITE, 0.5, 0.6, 0);
				BeginDBTransaction();
				if (name0R == 1)
					SetDBEntry("PlayerElos", name0, max(newelo0,500));
				else
					SetDBEntry("PlayerElosProv", name0, max(newelo0,500));
				if (name1R == 1)
					SetDBEntry("PlayerElos", name1, max(newelo1,500));
				else
					SetDBEntry("PlayerElosProv", name1, max(newelo1,500));
				EndDBTransaction();
				if (getcvar("elo_logmatches") == 1)
				{
					IncrementDBEntry("DuelElo","GameCount",1);
					int matchid = GetDBEntry("DuelElo","GameCount");
					str matchid_result = strparam(i:matchid,s:"_result");
					str matchid_player0 = strparam(i:matchid,s:"_player0");
					str matchid_player1 = strparam(i:matchid,s:"_player1");
					str matchid_player0_Frags = strparam(i:matchid,s:"_player0_Frags");
					str matchid_player1_Frags = strparam(i:matchid,s:"_player1_Frags");
					str matchid_map = strparam(i:matchid,s:"_map");
					str mapname = strparam(n:PRINTNAME_LEVEL);
					BeginDBTransaction();
					SetDBEntry("MatchResults",matchid_result,3); //0 = player 0 wins, 1 = player 1 wins, 2 = tie, 3 = player 0 ragequit, 4 = player 1 ragequit
					SetDBEntryString("MatchResults",matchid_player0,name0);
					SetDBEntryString("MatchResults",matchid_player1,name1);
					SetDBEntryString("MatchResults",matchid_map,mapname);
					SetDBEntry("MatchResults",matchid_player0_Frags,fragcount[0]);
					SetDBEntry("MatchResults",matchid_player1_Frags,fragcount[1]);
					EndDBTransaction();
				}
			}
		}
		roundinprogress = 0;
		break;
    // Etc
    }
}

script 354 ENTER
{
	str TempNamespace = strparam(i:getcvar("Elo_ServerID"),s:"_TempNames");
	if (active_players == 0)
	{
		duelplayer[playernumber()] = 0;
		duelplayernum[0] = playernumber();
		active_players++;
		SetDBEntryString (TempNamespace, "Player0", GetPlayerAccountName(playernumber())); //store name in case someone rage quits
	}
	else
	{
		duelplayer[playernumber()] = 1;
		duelplayernum[1] = playernumber();
		SetDBEntryString (TempNamespace, "Player1", GetPlayerAccountName(playernumber()));
	}
}
		

script 355 DEATH
{
	if (roundinprogress == 0)
		terminate;
	fragcount[duelplayer[playernumber()]] = playerfrags();
	deathcount[duelplayer[playernumber()]]++;
}
script 356 OPEN
{
	hudmessage(s:"";HUDMSG_PLAIN | HUDMSG_LOG, 311, CR_WHITE, 0.5, 0.6, 0);
	if (getcvar("delo_debug") == 0)
		terminate;
	while(TRUE)
	{
		hudmessage(n:duelplayernum[0] + 1,s:" frags: ",i:fragcount[0],s:"\n",n:duelplayernum[1] + 1,s:" frags: ",i:fragcount[1];
				HUDMSG_PLAIN, 314, CR_WHITE, 0.05, 0.6, 0);
		delay(35);
	}
}

script 357 OPEN //display leaderboard on start map
{
	str levname = strparam(n:PRINTNAME_LEVEL);
	if (getlevelinfo(LEVELINFO_CLUSTERNUM) == 99)
	{
		int Top8 = SortDBEntries ("PlayerElos", 8, 0, 1 );
		int numEntries = CountDBResults(Top8);
		while(TRUE)
		{
		if (numEntries == 8)
		{
			hudmessage(s:"Top Duel Players\n(Play at least 10 games to get ranked)\n",s:"1st: ",s:GetDBResultKeyString(Top8, 0),s:" Elo: ",i:GetDBResultValue(Top8, 0),s:"\n",
			s:"2nd: ",s:GetDBResultKeyString(Top8, 1),s:" Elo: ",i:GetDBResultValue(Top8, 1),s:"\n",
			s:"3rd: ",s:GetDBResultKeyString(Top8, 2),s:" Elo: ",i:GetDBResultValue(Top8, 2),s:"\n",
			s:"4th: ",s:GetDBResultKeyString(Top8, 3),s:" Elo: ",i:GetDBResultValue(Top8, 3),s:"\n",
			s:"5th: ",s:GetDBResultKeyString(Top8, 4),s:" Elo: ",i:GetDBResultValue(Top8, 4),s:"\n",
			s:"6th: ",s:GetDBResultKeyString(Top8, 5),s:" Elo: ",i:GetDBResultValue(Top8, 5),s:"\n",
			s:"7th: ",s:GetDBResultKeyString(Top8, 6),s:" Elo: ",i:GetDBResultValue(Top8, 6),s:"\n",
			s:"8th: ",s:GetDBResultKeyString(Top8, 7),s:" Elo: ",i:GetDBResultValue(Top8, 7);
				HUDMSG_PLAIN, 309, CR_WHITE, 0.7, 0.1, 0);
		}
		else if (numEntries == 7)
		{
			hudmessage(s:"Top Duel Players\n(Play at least 10 games to get ranked)\n",s:"1st: ",s:GetDBResultKeyString(Top8, 0),s:" Elo: ",i:GetDBResultValue(Top8, 0),s:"\n",
			s:"2nd: ",s:GetDBResultKeyString(Top8, 1),s:" Elo: ",i:GetDBResultValue(Top8, 1),s:"\n",
			s:"3rd: ",s:GetDBResultKeyString(Top8, 2),s:" Elo: ",i:GetDBResultValue(Top8, 2),s:"\n",
			s:"4th: ",s:GetDBResultKeyString(Top8, 3),s:" Elo: ",i:GetDBResultValue(Top8, 3),s:"\n",
			s:"5th: ",s:GetDBResultKeyString(Top8, 4),s:" Elo: ",i:GetDBResultValue(Top8, 4),s:"\n",
			s:"6th: ",s:GetDBResultKeyString(Top8, 5),s:" Elo: ",i:GetDBResultValue(Top8, 5),s:"\n",
			s:"7th: ",s:GetDBResultKeyString(Top8, 6),s:" Elo: ",i:GetDBResultValue(Top8, 6),s:"\n";
				HUDMSG_PLAIN, 309, CR_WHITE, 0.7, 0.1, 0);
		}
		else if (numEntries == 6)
		{
			hudmessage(s:"Top Duel Players\n(Play at least 10 games to get ranked)\n",s:"1st: ",s:GetDBResultKeyString(Top8, 0),s:" Elo: ",i:GetDBResultValue(Top8, 0),s:"\n",
			s:"2nd: ",s:GetDBResultKeyString(Top8, 1),s:" Elo: ",i:GetDBResultValue(Top8, 1),s:"\n",
			s:"3rd: ",s:GetDBResultKeyString(Top8, 2),s:" Elo: ",i:GetDBResultValue(Top8, 2),s:"\n",
			s:"4th: ",s:GetDBResultKeyString(Top8, 3),s:" Elo: ",i:GetDBResultValue(Top8, 3),s:"\n",
			s:"5th: ",s:GetDBResultKeyString(Top8, 4),s:" Elo: ",i:GetDBResultValue(Top8, 4),s:"\n",
			s:"6th: ",s:GetDBResultKeyString(Top8, 5),s:" Elo: ",i:GetDBResultValue(Top8, 5),s:"\n";
				HUDMSG_PLAIN, 309, CR_WHITE, 0.7, 0.1, 0);
		}
		else if (numEntries == 5)
		{
			hudmessage(s:"Top Duel Players\n(Play at least 10 games to get ranked)\n",s:"1st: ",s:GetDBResultKeyString(Top8, 0),s:" Elo: ",i:GetDBResultValue(Top8, 0),s:"\n",
			s:"2nd: ",s:GetDBResultKeyString(Top8, 1),s:" Elo: ",i:GetDBResultValue(Top8, 1),s:"\n",
			s:"3rd: ",s:GetDBResultKeyString(Top8, 2),s:" Elo: ",i:GetDBResultValue(Top8, 2),s:"\n",
			s:"4th: ",s:GetDBResultKeyString(Top8, 3),s:" Elo: ",i:GetDBResultValue(Top8, 3),s:"\n",
			s:"5th: ",s:GetDBResultKeyString(Top8, 4),s:" Elo: ",i:GetDBResultValue(Top8, 4),s:"\n";
				HUDMSG_PLAIN, 309, CR_WHITE, 0.7, 0.1, 0);
		}
		else if (numEntries == 4)
		{
			hudmessage(s:"Top Duel Players\n(Play at least 10 games to get ranked)\n",s:"1st: ",s:GetDBResultKeyString(Top8, 0),s:" Elo: ",i:GetDBResultValue(Top8, 0),s:"\n",
			s:"2nd: ",s:GetDBResultKeyString(Top8, 1),s:" Elo: ",i:GetDBResultValue(Top8, 1),s:"\n",
			s:"3rd: ",s:GetDBResultKeyString(Top8, 2),s:" Elo: ",i:GetDBResultValue(Top8, 2),s:"\n",
			s:"4th: ",s:GetDBResultKeyString(Top8, 3),s:" Elo: ",i:GetDBResultValue(Top8, 3),s:"\n";
				HUDMSG_PLAIN, 309, CR_WHITE, 0.7, 0.1, 0);
		}
		else if (numEntries == 3)
		{
			hudmessage(s:"Top Duel Players\n(Play at least 10 games to get ranked)\n",s:"1st: ",s:GetDBResultKeyString(Top8, 0),s:" Elo: ",i:GetDBResultValue(Top8, 0),s:"\n",
			s:"2nd: ",s:GetDBResultKeyString(Top8, 1),s:" Elo: ",i:GetDBResultValue(Top8, 1),s:"\n",
			s:"3rd: ",s:GetDBResultKeyString(Top8, 2),s:" Elo: ",i:GetDBResultValue(Top8, 2),s:"\n";
				HUDMSG_PLAIN, 309, CR_WHITE, 0.7, 0.1, 0);
		}
		else if (numEntries == 2)
		{
			hudmessage(s:"Top Duel Players\n(Play at least 10 games to get ranked)\n",s:"1st: ",s:GetDBResultKeyString(Top8, 0),s:" Elo: ",i:GetDBResultValue(Top8, 0),s:"\n",
			s:"2nd: ",s:GetDBResultKeyString(Top8, 1),s:" Elo: ",i:GetDBResultValue(Top8, 1),s:"\n";
				HUDMSG_PLAIN, 309, CR_WHITE, 0.7, 0.1, 0);
		}
		else if (numEntries == 1)
		{
			hudmessage(s:"Top Duel Players\n(Play at least 10 games to get ranked)\n",s:"1st: ",s:GetDBResultKeyString(Top8, 0),s:" Elo: ",i:GetDBResultValue(Top8, 0),s:"\n";
				HUDMSG_PLAIN, 309, CR_WHITE, 0.7, 0.1, 0);
		}
		else if (numEntries == 0)
		{
			hudmessage(s:"Nobody has played 10 duel matches yet, ranking not available";
				HUDMSG_PLAIN, 309, CR_WHITE, 0.7, 0.1, 0);
		}
		delay(35*5);
		}
	}
	else if (getcvar("delo_debug") == 1)
	{
		printbold(s:"not start?");
		log(s:"not start?");
	}
}

script 358 (int player) DISCONNECT
{
	whimp = player;
}

script 359 (void) NET
{
	print(i:roundinprogress);
	str TempNamespace = strparam(i:getcvar("Elo_ServerID"),s:"_TempNames");
	str name0 = GetDBEntryString (TempNamespace, "Player0");
	str name1 = GetDBEntryString (TempNamespace, "Player1");
	printbold(s:"Player 0: ",s:name0);
	printbold(s:"Player 1: ",s:name1);
}

script 360 OPEN CLIENTSIDE
{
	consolecommand("puke 361");
}

script 361 (void) NET
{
	int secs = 0;
	while(PlayerIsLoggedIn(playernumber()) == 0)
    {
		delay(35);
    }
	if (joined[playernumber()] == 1)
		terminate;
	str yourname = GetPlayerAccountName(playernumber()); 
    if (GetDBEntry("PlayerElosProv", yourname ) == 0)
	{
		SetDBEntry("PlayerElosProv", yourname, 1200);
		SetDBEntry("GamesPlayed", yourname, 0);
	}
	if (joined[playernumber()] == 1)
		terminate;
	if (GetDBEntry("Rankable", yourname ) == 1)
	{
		hudmessage(s:"Your ELO:\n",i:GetDBEntry("PlayerElos", yourname),s:"\nRank: ",i:GetDBEntryRank("PlayerElos", yourname, TRUE);
                HUDMSG_PLAIN, 304, CR_WHITE, 0.05, 0.8, 0);
	}
	else
	{
		hudmessage(s:"Your ELO:\n",i:GetDBEntry("PlayerElosProv", yourname),s:"\nComplete 10 matches\nto be ranked.";
            HUDMSG_PLAIN, 304, CR_WHITE, 0.05, 0.8, 0);
	}
}